#ifndef TABLEAU_H
#define TABLEAU_H

#include <vector>

#include "model.h"

//==============================================================================
class Tableau : public Model
{
public:
	Tableau(const Formula * f);

	virtual inline ~Tableau() {}

	virtual std::string reformat(const Formula * f) const;

private:
	void buildElementaryFormulas(const Formula *f);
	void buildStates(void);
	void constructTransitions(void);
	void buildFairness(void);
	
	std::map<const Formula *, std::string> reformatter;
};
//==============================================================================
#endif
